diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/model/eht/eht-frame-exchange-manager.cc ns-3.46/src/wifi/model/eht/eht-frame-exchange-manager.cc
--- ns-3.45/src/wifi/model/eht/eht-frame-exchange-manager.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/model/eht/eht-frame-exchange-manager.cc	2025-10-01 18:46:32.000000000 -0700
@@ -53,10 +53,17 @@
 TypeId
 EhtFrameExchangeManager::GetTypeId()
 {
-    static TypeId tid = TypeId("ns3::EhtFrameExchangeManager")
-                            .SetParent<HeFrameExchangeManager>()
-                            .AddConstructor<EhtFrameExchangeManager>()
-                            .SetGroupName("Wifi");
+    static TypeId tid =
+        TypeId("ns3::EhtFrameExchangeManager")
+            .SetParent<HeFrameExchangeManager>()
+            .AddConstructor<EhtFrameExchangeManager>()
+            .SetGroupName("Wifi")
+            .AddAttribute("EarlyTxopEndDetect",
+                          "Whether the Duration/ID value of the frame being transmitted "
+                          "or received can be used to early detect an ongoing TXOP end.",
+                          BooleanValue(true),
+                          MakeBooleanAccessor(&EhtFrameExchangeManager::m_earlyTxopEndDetect),
+                          MakeBooleanChecker());
     return tid;
 }
 
@@ -213,7 +220,10 @@
                 }
 
                 // check that this link is blocked as expected
-                WifiContainerQueueId queueId(WIFI_QOSDATA_QUEUE, WIFI_UNICAST, *mldAddress, 0);
+                WifiContainerQueueId queueId(WIFI_QOSDATA_QUEUE,
+                                             WifiRcvAddr::UNICAST,
+                                             *mldAddress,
+                                             0);
                 auto mask =
                     m_apMac->GetMacQueueScheduler()->GetQueueLinkMask(AC_BE, queueId, m_linkId);
                 NS_ASSERT_MSG(mask,
@@ -234,8 +244,6 @@
         }
     }
 
-    std::optional<Time> timeToCtsEnd;
-
     if (m_staMac && m_staMac->IsEmlsrLink(m_linkId))
     {
         // Cannot start a transmission on a link blocked because another EMLSR link is being used
@@ -335,7 +343,7 @@
     // EHT-SIG, the equivalent of HE-SIG-B, is present in EHT SU transmissions, too
     if (txVector.GetPreambleType() == WIFI_PREAMBLE_EHT_MU)
     {
-        auto phy = StaticCast<EhtPhy>(m_phy->GetPhyEntity(WIFI_MOD_CLASS_EHT));
+        auto phy = std::static_pointer_cast<EhtPhy>(m_phy->GetPhyEntity(WIFI_MOD_CLASS_EHT));
         auto sigBMode = phy->GetSigBMode(txVector);
         txVector.SetSigBMode(sigBMode);
     }
@@ -464,7 +472,7 @@
             const auto psduMapIt = psduMap.find(aid);
             const auto aidNotFoundAndNotTf = (psduMapIt == psduMap.cend()) && !IsTrigger(psduMap);
             // the PSDU to process: the one addressed to the given AID (if any) or the unique one
-            const auto psdu = (psduMapIt != psduMap.cend() ? psduMapIt : psduMap.cbegin())->second;
+            const auto psdu = (psduMapIt != psduMap.cend() ? psduMapIt : psduMap.begin())->second;
 
             if (GetWifiRemoteStationManager()->GetEmlsrEnabled(*clientIt) &&
                 (aidNotFoundAndNotTf || GetEmlsrSwitchToListening(psdu, aid, *clientIt)))
@@ -1111,7 +1119,10 @@
                 m_mac->GetWifiRemoteStationManager(linkId)->GetEmlsrEnabled(*mldAddress))
             {
                 // check that other links are blocked as expected
-                WifiContainerQueueId queueId(WIFI_QOSDATA_QUEUE, WIFI_UNICAST, *mldAddress, 0);
+                WifiContainerQueueId queueId(WIFI_QOSDATA_QUEUE,
+                                             WifiRcvAddr::UNICAST,
+                                             *mldAddress,
+                                             0);
                 auto mask =
                     m_apMac->GetMacQueueScheduler()->GetQueueLinkMask(AC_BE, queueId, linkId);
                 NS_ASSERT_MSG(mask, "No mask for client " << *mldAddress << " on link " << +linkId);
@@ -1505,7 +1516,7 @@
             m_staMac->IsEmlsrLink(m_linkId))
         {
             // this is an initial Control frame
-            if (DropReceivedIcf())
+            if (DropReceivedIcf(mpdu))
             {
                 return;
             }
@@ -1515,10 +1526,29 @@
     }
     else if (m_staMac && m_staMac->IsEmlsrLink(m_linkId) && !m_ongoingTxopEnd.IsPending() &&
              m_phy->GetPhyId() == m_staMac->GetEmlsrManager()->GetMainPhyId() &&
-             (hdr.IsRts() || hdr.IsBlockAckReq() || (hdr.IsData() && hdr.GetAddr1() == m_self)))
+             (hdr.IsRts() || hdr.IsBlockAckReq() || hdr.IsData()) && hdr.GetAddr1() == m_self)
     {
-        // a frame that is starting a DL TXOP has been received by the main PHY
+        // a frame that is starting a DL TXOP has been received by the main PHY, check if the frame
+        // shall be dropped
+        if (DropReceivedIcf(mpdu))
+        {
+            return;
+        }
+
         m_dlTxopStart = true;
+
+        if (inAmpdu)
+        {
+            // start blocking transmission on other links (which is normally done later on by
+            // PostProcessFrame()) to avoid starting an UL TXOP before end of A-MPDU
+            for (auto id : m_staMac->GetLinkIds())
+            {
+                if (id != m_linkId && m_staMac->IsEmlsrLink(id))
+                {
+                    m_staMac->BlockTxOnLink(id, WifiQueueBlockedReason::USING_OTHER_EMLSR_LINK);
+                }
+            }
+        }
     }
 
     if (!m_dlTxopStart && ShallDropReceivedMpdu(mpdu))
@@ -1544,33 +1574,6 @@
     }
 }
 
-void
-EhtFrameExchangeManager::EndReceiveAmpdu(Ptr<const WifiPsdu> psdu,
-                                         const RxSignalInfo& rxSignalInfo,
-                                         const WifiTxVector& txVector,
-                                         const std::vector<bool>& perMpduStatus)
-{
-    NS_LOG_FUNCTION(
-        this << *psdu << rxSignalInfo << txVector << perMpduStatus.size()
-             << std::all_of(perMpduStatus.begin(), perMpduStatus.end(), [](bool v) { return v; }));
-
-    const auto& hdr = psdu->GetHeader(0);
-    if (m_staMac && m_staMac->IsEmlsrLink(m_linkId) && !m_ongoingTxopEnd.IsPending() &&
-        m_phy->GetPhyId() == m_staMac->GetEmlsrManager()->GetMainPhyId() &&
-        (hdr.IsData() && hdr.GetAddr1() == m_self))
-    {
-        // a frame that is starting a DL TXOP has been received by the main PHY
-        m_dlTxopStart = true;
-    }
-
-    if (!m_dlTxopStart && ShallDropReceivedMpdu(*psdu->begin()))
-    {
-        return;
-    }
-
-    HeFrameExchangeManager::EndReceiveAmpdu(psdu, rxSignalInfo, txVector, perMpduStatus);
-}
-
 bool
 EhtFrameExchangeManager::ShallDropReceivedMpdu(Ptr<const WifiMpdu> mpdu) const
 {
@@ -1639,9 +1642,9 @@
 }
 
 bool
-EhtFrameExchangeManager::DropReceivedIcf()
+EhtFrameExchangeManager::DropReceivedIcf(Ptr<const WifiMpdu> icf)
 {
-    NS_LOG_FUNCTION(this);
+    NS_LOG_FUNCTION(this << *icf);
 
     auto emlsrManager = m_staMac->GetEmlsrManager();
     NS_ASSERT(emlsrManager);
@@ -1650,8 +1653,10 @@
     {
         // we received an ICF on a link that is blocked because another EMLSR link is
         // being used. Check if there is an ongoing DL TXOP on the other EMLSR link
-        auto apMldAddress = GetWifiRemoteStationManager()->GetMldAddress(m_bssid);
-        NS_ASSERT_MSG(apMldAddress, "MLD address not found for " << m_bssid);
+        auto addr2 = icf->GetHeader().GetAddr2();
+        const auto sender = GetWifiRemoteStationManager()->GetMldAddress(addr2).value_or(addr2);
+        NS_ASSERT_MSG(addr2 != m_bssid || sender != m_bssid,
+                      "If the ICF is not sent by an adhoc peer, it must be sent by an (AP) MLD");
 
         if (auto it = std::find_if(
                 m_staMac->GetLinkIds().cbegin(),
@@ -1662,27 +1667,29 @@
                         StaticCast<EhtFrameExchangeManager>(m_mac->GetFrameExchangeManager(linkId));
                     return linkId != m_linkId && m_staMac->IsEmlsrLink(linkId) &&
                            ehtFem->m_ongoingTxopEnd.IsPending() && ehtFem->m_txopHolder &&
-                           m_mac->GetWifiRemoteStationManager(linkId)->GetMldAddress(
-                               *ehtFem->m_txopHolder) == apMldAddress;
+                           m_mac->GetWifiRemoteStationManager(linkId)
+                                   ->GetMldAddress(*ehtFem->m_txopHolder)
+                                   .value_or(*ehtFem->m_txopHolder) == sender;
                 });
             it != m_staMac->GetLinkIds().cend())
         {
-            // AP is not expected to send ICFs on two links. If an ICF
-            // has been received on this link, it means that the DL TXOP
-            // on the other link terminated (e.g., the AP did not
-            // receive our response)
+            // A device is not expected to send ICFs on two links. If an ICF has been received on
+            // this link, it means that the DL TXOP on the other link terminated (e.g., the device
+            // did not receive our response)
             StaticCast<EhtFrameExchangeManager>(m_mac->GetFrameExchangeManager(*it))
                 ->m_ongoingTxopEnd.Cancel();
-            // we are going to start a TXOP on this link; unblock
-            // transmissions on this link, the other links will be
-            // blocked subsequently
+            // we are going to start a TXOP on this link; unblock transmissions on this link, the
+            // other links will be blocked subsequently
             m_staMac->UnblockTxOnLink({m_linkId}, WifiQueueBlockedReason::USING_OTHER_EMLSR_LINK);
         }
         else
         {
-            // We get here likely because transmission on the other EMLSR link
-            // started before the reception of the ICF ended. We drop this ICF and let the
-            // UL TXOP continue.
+            // We get here if either there is an ongoing DL TXOP on another EMLSR link but the
+            // TXOP holder is not the sender of the ICF (this may happen when the EMLSR client
+            // receives ICFs from the AP and a peer adhoc STA) or there is an ongoing UL TXOP on
+            // the other EMLSR link (which likely happens when a transmission on the other EMLSR
+            // link started before the reception of the ICF ended). In both cases, we drop this ICF
+            // and let the TXOP on the other EMLSR link continue.
             NS_LOG_DEBUG("Drop ICF because another EMLSR link is being used");
             m_icfDropCallback({WifiIcfDrop::USING_OTHER_LINK, m_linkId, m_bssid});
             return true;
@@ -1776,7 +1783,7 @@
         // the response)
         delay = m_txTimer.GetDelayLeft();
     }
-    else if (durationId <= m_phy->GetSifs())
+    else if (m_earlyTxopEndDetect && durationId <= m_phy->GetSifs())
     {
         // the TX timer is not running, hence no response is expected, and the Duration/ID value
         // is less than or equal to a SIFS; the TXOP will end after this transmission
@@ -1790,8 +1797,11 @@
         // after the end of this PPDU, hence we need to postpone the TXOP end in order to
         // get the PHY-RXSTART.indication
         delay = txDuration + m_phy->GetSifs() + m_phy->GetSlot() + EMLSR_RX_PHY_START_DELAY;
-        // TXOP end cannot be beyond the period protected via Duration/ID
-        delay = Min(delay, txDuration + durationId);
+        if (m_earlyTxopEndDetect)
+        {
+            // TXOP end cannot be beyond the period protected via Duration/ID
+            delay = Min(delay, txDuration + durationId);
+        }
     }
 
     NS_LOG_DEBUG("Expected TXOP end=" << (Simulator::Now() + delay).As(Time::S));
@@ -1835,7 +1845,7 @@
 
     // if the Duration/ID of the received frame is less than a SIFS, the TXOP
     // is terminated
-    if (durationId <= m_phy->GetSifs())
+    if (m_earlyTxopEndDetect && durationId <= m_phy->GetSifs())
     {
         NS_LOG_DEBUG("Assume TXOP ended based on Duration/ID value");
         TxopEnd(m_txopHolder);
@@ -1845,8 +1855,11 @@
     // we may send a response after a SIFS or we may receive another frame after a SIFS.
     // Postpone the TXOP end by considering the latter (which takes longer)
     auto delay = m_phy->GetSifs() + m_phy->GetSlot() + EMLSR_RX_PHY_START_DELAY;
-    // TXOP end cannot be beyond the period protected via Duration/ID
-    delay = Min(delay, durationId);
+    if (m_earlyTxopEndDetect)
+    {
+        // TXOP end cannot be beyond the period protected via Duration/ID
+        delay = Min(delay, durationId);
+    }
     NS_LOG_DEBUG("Expected TXOP end=" << (Simulator::Now() + delay).As(Time::S));
     m_ongoingTxopEnd =
         Simulator::Schedule(delay, &EhtFrameExchangeManager::TxopEnd, this, m_txopHolder);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/model/eht/eht-frame-exchange-manager.h ns-3.46/src/wifi/model/eht/eht-frame-exchange-manager.h
--- ns-3.45/src/wifi/model/eht/eht-frame-exchange-manager.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/model/eht/eht-frame-exchange-manager.h	2025-10-01 18:46:32.000000000 -0700
@@ -189,10 +189,6 @@
                      RxSignalInfo rxSignalInfo,
                      const WifiTxVector& txVector,
                      bool inAmpdu) override;
-    void EndReceiveAmpdu(Ptr<const WifiPsdu> psdu,
-                         const RxSignalInfo& rxSignalInfo,
-                         const WifiTxVector& txVector,
-                         const std::vector<bool>& perMpduStatus) override;
     void NavResetTimeout() override;
     void IntraBssNavResetTimeout() override;
     void SendCtsAfterRts(const WifiMacHeader& rtsHdr,
@@ -247,12 +243,16 @@
      */
     bool UnblockEmlsrLinksIfAllowed(Mac48Address address, bool checkThisLink);
 
+    bool m_earlyTxopEndDetect; ///< whether the Duration/ID value of the frame being transmitted
+                               ///< or received can be used to early detect an ongoing TXOP end
+
   private:
     /**
+     * @param icf the received ICF
      * @return whether the received ICF must be dropped because we are unable to process it
      *         (e.g., another EMLSR link is being used or there is no time for main PHY switch)
      */
-    bool DropReceivedIcf();
+    bool DropReceivedIcf(Ptr<const WifiMpdu> icf);
 
     /**
      * For each EMLSR client in the given set of clients that did not respond to a frame requesting
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/model/eht/eht-phy.cc ns-3.46/src/wifi/model/eht/eht-phy.cc
--- ns-3.45/src/wifi/model/eht/eht-phy.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/model/eht/eht-phy.cc	2025-10-01 18:46:32.000000000 -0700
@@ -565,7 +565,7 @@
     ConstructorEht()
     {
         ns3::EhtPhy::InitializeModes();
-        ns3::WifiPhy::AddStaticPhyEntity(ns3::WIFI_MOD_CLASS_EHT, ns3::Create<ns3::EhtPhy>());
+        ns3::WifiPhy::AddStaticPhyEntity(ns3::WIFI_MOD_CLASS_EHT, std::make_shared<ns3::EhtPhy>());
     }
 } g_constructor_eht; ///< the constructor for EHT modes
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/model/eht/eht-ru.cc ns-3.46/src/wifi/model/eht/eht-ru.cc
--- ns-3.45/src/wifi/model/eht/eht-ru.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/model/eht/eht-ru.cc	2025-10-01 18:46:32.000000000 -0700
@@ -1064,6 +1064,9 @@
 {
     const auto it = m_ruSubcarrierGroups.find({bw, ruType});
     NS_ABORT_MSG_IF(it == m_ruSubcarrierGroups.cend(), "RU not found");
+    NS_ABORT_MSG_IF(phyIndex == 0 || phyIndex > it->second.size(),
+                    "Invalid PHY index " << phyIndex << " for RU type " << ruType
+                                         << " and bandwidth " << bw);
     return it->second.at(phyIndex - 1);
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/model/eht/emlsr-manager.h ns-3.46/src/wifi/model/eht/emlsr-manager.h
--- ns-3.45/src/wifi/model/eht/emlsr-manager.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/model/eht/emlsr-manager.h	2025-10-01 18:46:32.000000000 -0700
@@ -80,6 +80,7 @@
 {
     /// Allow test cases to access private members
     friend class ::EmlsrCcaBusyTest;
+    friend class WifiStaticSetupHelper;
 
   public:
     /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/model/he/constant-obss-pd-algorithm.cc ns-3.46/src/wifi/model/he/constant-obss-pd-algorithm.cc
--- ns-3.45/src/wifi/model/he/constant-obss-pd-algorithm.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/model/he/constant-obss-pd-algorithm.cc	2025-10-01 18:46:32.000000000 -0700
@@ -48,11 +48,12 @@
     auto phy = device->GetPhy();
     if (phy->GetStandard() >= WIFI_STANDARD_80211be)
     {
-        auto ehtPhy = DynamicCast<EhtPhy>(device->GetPhy()->GetPhyEntity(WIFI_MOD_CLASS_EHT));
+        auto ehtPhy =
+            std::dynamic_pointer_cast<EhtPhy>(device->GetPhy()->GetPhyEntity(WIFI_MOD_CLASS_EHT));
         NS_ASSERT(ehtPhy);
         ehtPhy->SetEndOfHeSigACallback(MakeCallback(&ConstantObssPdAlgorithm::ReceiveHeSigA, this));
     }
-    auto hePhy = DynamicCast<HePhy>(phy->GetPhyEntity(WIFI_MOD_CLASS_HE));
+    auto hePhy = std::dynamic_pointer_cast<HePhy>(phy->GetPhyEntity(WIFI_MOD_CLASS_HE));
     NS_ASSERT(hePhy);
     hePhy->SetEndOfHeSigACallback(MakeCallback(&ConstantObssPdAlgorithm::ReceiveHeSigA, this));
     ObssPdAlgorithm::ConnectWifiNetDevice(device);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/model/he/he-frame-exchange-manager.cc ns-3.46/src/wifi/model/he/he-frame-exchange-manager.cc
--- ns-3.45/src/wifi/model/he/he-frame-exchange-manager.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/model/he/he-frame-exchange-manager.cc	2025-10-01 18:46:32.000000000 -0700
@@ -644,8 +644,8 @@
             ForwardPsduDown(triggerPsdu, acknowledgment->muBarTxVector);
 
             // Pass TRIGVECTOR to HE PHY (equivalent to PHY-TRIGGER.request primitive)
-            auto hePhy =
-                StaticCast<HePhy>(m_phy->GetPhyEntity(responseTxVector->GetModulationClass()));
+            auto hePhy = std::static_pointer_cast<HePhy>(
+                m_phy->GetPhyEntity(responseTxVector->GetModulationClass()));
             hePhy->SetTrigVector(m_trigVector, timeout);
 
             return;
@@ -892,7 +892,8 @@
         timerType == WifiTxTimer::WAIT_QOS_NULL_AFTER_BSRP_TF)
     {
         // Pass TRIGVECTOR to HE PHY (equivalent to PHY-TRIGGER.request primitive)
-        auto hePhy = StaticCast<HePhy>(m_phy->GetPhyEntity(responseTxVector->GetModulationClass()));
+        auto hePhy = std::static_pointer_cast<HePhy>(
+            m_phy->GetPhyEntity(responseTxVector->GetModulationClass()));
         hePhy->SetTrigVector(m_trigVector, m_txTimer.GetDelayLeft());
     }
     else if (timerType == WifiTxTimer::NOT_RUNNING &&
@@ -929,7 +930,8 @@
 
     if (ns3::IsDlMu(txVector.GetPreambleType()))
     {
-        auto hePhy = StaticCast<HePhy>(m_phy->GetPhyEntity(txVector.GetModulationClass()));
+        auto hePhy =
+            std::static_pointer_cast<HePhy>(m_phy->GetPhyEntity(txVector.GetModulationClass()));
         auto sigBMode = hePhy->GetSigBMode(txVector);
         txVector.SetSigBMode(sigBMode);
     }
@@ -1510,7 +1512,7 @@
     NS_ASSERT_MSG(heConfiguration, "This STA has to be an HE station to send an HE TB PPDU");
     v.SetBssColor(heConfiguration->m_bssColor);
 
-    if (userInfoIt->IsUlTargetRssiMaxTxPower())
+    if (userInfoIt->IsUlTargetRxPowerMaxTxPower())
     {
         NS_LOG_LOGIC("AP requested using the max transmit power (" << m_phy->GetTxPowerEnd()
                                                                    << " dBm)");
@@ -1542,7 +1544,7 @@
         trigger.GetApTxPower() -
         static_cast<int8_t>(
             *optRssi); // cast RSSI to be on equal footing with AP Tx power information
-    auto reqTxPower = dBm_u{static_cast<double>(userInfoIt->GetUlTargetRssi() + pathLossDb)};
+    auto reqTxPower = dBm_u{static_cast<double>(userInfoIt->GetUlTargetRxPower() + pathLossDb)};
 
     // Convert the transmit power to a power level
     uint8_t numPowerLevels = m_phy->GetNTxPower();
@@ -1594,12 +1596,20 @@
         auto itAidAddr = staList.find(userInfo.GetAid12());
         NS_ASSERT(itAidAddr != staList.end());
         auto optRssi = GetMostRecentRssi(itAidAddr->second);
+        if (!optRssi.has_value())
+        {
+            // This might happen after static setup where the AP has not received any
+            // frame from the client yet.
+            userInfo.SetUlTargetRxPowerMaxTxPower();
+            continue;
+        }
+
         NS_ASSERT(optRssi);
         auto rssi = static_cast<int8_t>(*optRssi);
         rssi = (rssi >= -20)
                    ? -20
                    : ((rssi <= -110) ? -110 : rssi); // cap so as to keep within [-110; -20] dBm
-        userInfo.SetUlTargetRssi(rssi);
+        userInfo.SetUlTargetRxPower(rssi);
     }
 }
 
@@ -1899,7 +1909,7 @@
     // TR3: Sequence numbers for transmitted QoS (+)Null frames may be set
     // to any value. (Table 10-3 of 802.11-2016)
     header.SetSequenceNumber(0);
-    // Set the EOSP bit so that NotifyTxToEdca will add the Queue Size
+    // Set the EOSP bit so that HtFEM::FinalizeMacHeader will add the Queue Size
     header.SetQosEosp();
 
     WifiTxParameters txParams;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/model/he/he-phy.cc ns-3.46/src/wifi/model/he/he-phy.cc
--- ns-3.45/src/wifi/model/he/he-phy.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/model/he/he-phy.cc	2025-10-01 18:46:32.000000000 -0700
@@ -992,6 +992,7 @@
                             channelWidth,
                             m_wifiPhy->GetOperatingChannel().GetPrimaryChannelIndex(MHz_u{20})),
         mc);
+    NS_ABORT_MSG_IF(group.empty(), "No subcarrier group found");
     // for a TX spectrum, the guard bandwidth is a function of the transmission channel width
     // and the spectrum width equals the transmission channel width (hence bandIndex equals 0)
     const auto indices = ConvertRuSubcarriers({channelWidth,
@@ -1027,6 +1028,7 @@
                             channelWidth,
                             m_wifiPhy->GetOperatingChannel().GetPrimaryChannelIndex(MHz_u{20})),
         mc);
+    NS_ABORT_MSG_IF(group.empty(), "No subcarrier group found");
     // for an RX spectrum, the guard bandwidth is a function of the operating channel width
     // and the spectrum width equals the operating channel width
     const auto indices = ConvertRuSubcarriers(
@@ -1888,7 +1890,7 @@
     ConstructorHe()
     {
         ns3::HePhy::InitializeModes();
-        ns3::WifiPhy::AddStaticPhyEntity(ns3::WIFI_MOD_CLASS_HE, ns3::Create<ns3::HePhy>());
+        ns3::WifiPhy::AddStaticPhyEntity(ns3::WIFI_MOD_CLASS_HE, std::make_shared<ns3::HePhy>());
     }
 } g_constructor_he; ///< the constructor for HE modes
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/model/he/obss-pd-algorithm.cc ns-3.46/src/wifi/model/he/obss-pd-algorithm.cc
--- ns-3.45/src/wifi/model/he/obss-pd-algorithm.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/model/he/obss-pd-algorithm.cc	2025-10-01 18:46:32.000000000 -0700
@@ -76,11 +76,13 @@
     auto phy = device->GetPhy();
     if (phy->GetStandard() >= WIFI_STANDARD_80211be)
     {
-        auto ehtPhy = DynamicCast<EhtPhy>(device->GetPhy()->GetPhyEntity(WIFI_MOD_CLASS_EHT));
+        auto ehtPhy =
+            std::dynamic_pointer_cast<EhtPhy>(device->GetPhy()->GetPhyEntity(WIFI_MOD_CLASS_EHT));
         NS_ASSERT(ehtPhy);
         ehtPhy->SetObssPdAlgorithm(this);
     }
-    auto hePhy = DynamicCast<HePhy>(device->GetPhy()->GetPhyEntity(WIFI_MOD_CLASS_HE));
+    auto hePhy =
+        std::dynamic_pointer_cast<HePhy>(device->GetPhy()->GetPhyEntity(WIFI_MOD_CLASS_HE));
     NS_ASSERT(hePhy);
     hePhy->SetObssPdAlgorithm(this);
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/model/he/rr-multi-user-scheduler.cc ns-3.46/src/wifi/model/he/rr-multi-user-scheduler.cc
--- ns-3.45/src/wifi/model/he/rr-multi-user-scheduler.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/model/he/rr-multi-user-scheduler.cc	2025-10-01 18:46:32.000000000 -0700
@@ -320,11 +320,11 @@
     // check if the station is an EMLSR client that is using another link
     if (GetWifiRemoteStationManager(m_linkId)->GetEmlsrEnabled(info.address) &&
         (m_apMac->GetTxBlockedOnLink(AC_BE,
-                                     {WIFI_QOSDATA_QUEUE, WIFI_UNICAST, *mldAddr, 0},
+                                     {WIFI_QOSDATA_QUEUE, WifiRcvAddr::UNICAST, *mldAddr, 0},
                                      m_linkId,
                                      WifiQueueBlockedReason::USING_OTHER_EMLSR_LINK) ||
          m_apMac->GetTxBlockedOnLink(AC_BE,
-                                     {WIFI_QOSDATA_QUEUE, WIFI_UNICAST, *mldAddr, 0},
+                                     {WIFI_QOSDATA_QUEUE, WifiRcvAddr::UNICAST, *mldAddr, 0},
                                      m_linkId,
                                      WifiQueueBlockedReason::WAITING_EMLSR_TRANSITION_DELAY)))
     {
@@ -1118,4 +1118,10 @@
     return UlMuInfo{m_trigger, m_triggerMacHdr, std::move(m_txParams)};
 }
 
+const std::list<RrMultiUserScheduler::MasterInfo>&
+RrMultiUserScheduler::GetUlMuStas() const
+{
+    return m_staListUl;
+}
+
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/model/he/rr-multi-user-scheduler.h ns-3.46/src/wifi/model/he/rr-multi-user-scheduler.h
--- ns-3.45/src/wifi/model/he/rr-multi-user-scheduler.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/model/he/rr-multi-user-scheduler.h	2025-10-01 18:46:32.000000000 -0700
@@ -44,6 +44,23 @@
 
     Time GetExtraTimeForBsrpTfDurationId(uint8_t linkId) const override;
 
+    /**
+     * Information used to sort stations
+     */
+    struct MasterInfo
+    {
+        uint16_t aid{0};      //!< station's AID
+        Mac48Address address; //!< station's MAC Address
+        double credits{0.};   //!< credits accumulated by the station
+    };
+
+    /**
+     * @brief Get UL MU eligible stations list
+     *
+     * @return list of UL MU eligible stations
+     */
+    virtual const std::list<MasterInfo>& GetUlMuStas() const;
+
   protected:
     void DoDispose() override;
     void DoInitialize() override;
@@ -56,16 +73,6 @@
                                    WifiTxParameters& txParams) const override;
 
     /**
-     * Information used to sort stations
-     */
-    struct MasterInfo
-    {
-        uint16_t aid;         //!< station's AID
-        Mac48Address address; //!< station's MAC Address
-        double credits;       //!< credits accumulated by the station
-    };
-
-    /**
      * Determine whether the given STA can be solicited via a Basic Trigger Frame.
      *
      * @param info the information about the given STA
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/model/ht/ht-frame-exchange-manager.cc ns-3.46/src/wifi/model/ht/ht-frame-exchange-manager.cc
--- ns-3.45/src/wifi/model/ht/ht-frame-exchange-manager.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/model/ht/ht-frame-exchange-manager.cc	2025-10-01 18:46:32.000000000 -0700
@@ -126,7 +126,7 @@
     // NOLINTEND(bugprone-branch-clone)
     else
     {
-        WifiContainerQueueId queueId{WIFI_QOSDATA_QUEUE, WIFI_UNICAST, recipient, tid};
+        WifiContainerQueueId queueId{WIFI_QOSDATA_QUEUE, WifiRcvAddr::UNICAST, recipient, tid};
         uint32_t packets = qosTxop->GetWifiMacQueue()->GetNPackets(queueId);
         establish =
             (m_mac->Is6GhzBand(m_linkId) ||
@@ -152,7 +152,7 @@
         m_mpduAggregator->GetMaxAmpduSize(groupAddress, tid, WIFI_MOD_CLASS_HT);
     const auto isGcrBa = (m_apMac->GetGcrManager()->GetRetransmissionPolicy() ==
                           GroupAddressRetransmissionPolicy::GCR_BLOCK_ACK);
-    WifiContainerQueueId queueId{WIFI_QOSDATA_QUEUE, WIFI_GROUPCAST, groupAddress, tid};
+    WifiContainerQueueId queueId{WIFI_QOSDATA_QUEUE, WifiRcvAddr::GROUPCAST, groupAddress, tid};
 
     for (const auto& recipients =
              m_apMac->GetGcrManager()->GetMemberStasForGroupAddress(groupAddress);
@@ -570,7 +570,7 @@
             if (bar->GetHeader().GetAddr2() == m_self && recipientMld)
             {
                 WifiContainerQueueId queueId{WIFI_CTL_QUEUE,
-                                             WIFI_UNICAST,
+                                             WifiRcvAddr::UNICAST,
                                              *recipientMld,
                                              std::nullopt};
                 Ptr<WifiMpdu> otherBar;
@@ -606,7 +606,7 @@
         {
             WifiContainerQueueId queueId(
                 WIFI_QOSDATA_QUEUE,
-                WIFI_UNICAST,
+                WifiRcvAddr::UNICAST,
                 GetWifiRemoteStationManager()->GetMldAddress(recipient).value_or(recipient),
                 tid);
             // check if data is queued and can be transmitted on this link
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/wifi/model/ht/ht-phy.cc ns-3.46/src/wifi/model/ht/ht-phy.cc
--- ns-3.45/src/wifi/model/ht/ht-phy.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/wifi/model/ht/ht-phy.cc	2025-10-01 18:46:32.000000000 -0700
@@ -262,7 +262,6 @@
                         << +nDataLtf << ")  and extension (" << +nExtensionLtf
                         << ")  LTFs numbers for HT"); // see IEEE 802.11-2016, section 19.3.9.4.6
                                                       // "HT-LTF definition"
-    Time duration = MicroSeconds(4) * (nDataLtf + nExtensionLtf);
     return MicroSeconds(4) * (1 /* HT-STF */ + nDataLtf + nExtensionLtf);
 }
 
@@ -939,7 +938,7 @@
     {
         ns3::HtPhy::InitializeModes();
         ns3::WifiPhy::AddStaticPhyEntity(ns3::WIFI_MOD_CLASS_HT,
-                                         ns3::Create<ns3::HtPhy>()); // dummy Nss
+                                         std::make_shared<ns3::HtPhy>()); // dummy Nss
     }
 } g_constructor_ht; ///< the constructor for HT modes
 
